require(['config'], function() {
	require([
	], function($) {
		mobPageObj.init();
	});
});

/*API URL*/
const API_MOBILE_GRID_LIST 			= '/api/pomng/detail-grid-list';	// 목록
const API_MOBILE_INFO 				= '/api/pomng/info-pchReq';			// 상세
const API_MOBILE_SAVE 				= '/api/pomng/save-pchReq';			// 저장
const API_POP_SEARCH_LIST			= '/api/whs/mng/pop-whs-search';

const PCH_REQ_ST_CD_TEMP_SAVE		="PR00";
const PCH_REQ_ST_CD_REQUEST_SAVE	="PR20";

const VIEW_MODE_LIST				= "LIST";
const VIEW_MODE_DETAIL				= "DETAIL";
const VIEW_MODE_MODIFY				= "MODIFY";

let mobPageObj = {
	init: function () {
		this.ui.init();
		this.event.init();
		this.ready();
	},
	ui: {
		init: function () {
			this.view();
			this.info();
			this.action();
		},
		view: function() {
			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});

			// 조회일자 지정
			$('#ITP_FORM_MPOMNG02010_SEARCH_FROM_DT').val(itp_fn_date_add('M', -1));
			$('#ITP_FORM_MPOMNG02010_SEARCH_TO_DT').val(itp_fn_date_add('M', 0));
		},
		info: function() {
			$('input:hidden[id$="_BRAND_ID"]').val(fn_make_user_info.get('brandId'));
			$('input:hidden[id$="_STORE_ID"]').val(fn_make_user_info.get('storeId'));
		},
		action: function() {
			$('#ITP_LIST_MPOMNG02010_LIST_AREA').on('scroll', function () {
				if($(this).scrollTop() + $(this).innerHeight() + 1 >= $(this)[0].scrollHeight) {
					if(mobContentObj.list.totPage > mobContentObj.list.listPage) {
						if(!mobContentObj.list.isSearch) {
							mobContentObj.list.load();
						}
					}
				}
			});
		}
	},
	event: {
		init: function() {
			this.button();
		},
		button: function() {
			$('button[id^="ITP_BTN_MPOMNG02010_"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MPOMNG02010_SEARCH_WHS_NM'	: mobPopObj.popWhsNm.init(VIEW_MODE_LIST); 		break;
					case 'ITP_BTN_MPOMNG02010_DELETE_WHS_NM'	: mobPopObj.popWhsNm.delete(VIEW_MODE_LIST); 		break;
					case 'ITP_BTN_MPOMNG02010_SEARCH'			: mobContentObj.list.search();		break;
					case 'ITP_BTN_MPOMNG02010_CANCEL_LIST'		: mobContentObj.detail.cancel();	break;
				}
				return false;
			});
		}
	},
	switchScreen: function(mode) {
		$('#ITP_MOBILE_MPOMNG02010').find('div[id$="_CONTAINER"]').each(function(i) {
			$(this).hide();
		});
		if(mode === VIEW_MODE_LIST) {
			$('#ITP_AJAX_MPOMNG02010_VIEW_CONTAINER').show();
		} else if(mode === VIEW_MODE_DETAIL) {
			$('#ITP_AJAX_MPOMNG02010_DETAIL_CONTAINER').show();
		} else if(mode === VIEW_MODE_MODIFY) {
			$('#ITP_AJAX_MPOMNG02010_MODIFY_CONTAINER').show();
		}
	},
	ready: function() {
		mobContentObj.list.init();
	}
};

let mobContentObj = {
	list: {
		listSize: 10,
		listPage: 0,
		totPage: 0,
		isSearch: false,
		rows: [],
		init: function() {
			mobPageObj.switchScreen(VIEW_MODE_LIST);
			this.load();
			this.action();
		},
		search: function() {
			this.listPage = 0;
			this.totPage = 0;
			this.rows.length = 0;
			$('#ITP_LIST_MPOMNG02010_LIST_ROWS').empty();
			this.load();
		},
		load: function() {
			var _this = this;
			this.isSearch = true;
			var callbackFn = function(result) {
				console.log(result);
				_this.isSearch = false;
				_this.totPage = result.gridTotal;
				$.each(result.gridRows, function (i, item) {
					$('#ITP_LIST_MPOMNG02010_LIST_AREA .panel-group').append($('#ITP_LIST_MPOMNG02010_LIST_ROWCOPY').html());
					var $li = $('#ITP_LIST_MPOMNG02010_LIST_AREA .panel-group > .list-row:last');
					$li.find('.fnPchReqDt').text(item.pchReqDt);
					$li.find('.fnPchReqMgrNm').text(item.pchReqMgrNm);
					$li.find('.fnPchReqStNm').text(item.pchReqStNm);
					$li.find('.fnWhsLocationNm').text(item.whsLocationNm);
					$li.find('.fnPchReqItemQty').text(CommonObj.comma.set(item.pchReqItemQty));
					$li.find('.fnPchReqTotalAmt').text(CommonObj.comma.set(item.pchReqTotalAmt));
					$li.find('.fnPchReqRjctNm').text(item.pchReqRjctNm);
					_this.rows.push(item);
				});
			};
			var errFn = function() { _this.isSearch = false;};
			const param = $('#ITP_FORM_MPOMNG02010_SEARCH').serializeObject();
			param.gridPage = ++this.listPage;
			param.gridSize = this.listSize;
			param.fromDt = param.fromDt.replace(/-/g, ".");
			param.toDt = param.toDt.replace(/-/g, ".");
			fn_ajax_call(API_MOBILE_GRID_LIST, JSON.stringify(param), callbackFn, 'POST', errFn);
		},
		action: function () {
			var _this = this;
			$(document).on('click', '#ITP_LIST_MPOMNG02010_LIST_ROWS li', function() {
				var index = $(this).index();
				var item = _this.rows[index];
				(item.pchReqStCd === PCH_REQ_ST_CD_TEMP_SAVE) ? mobContentObj.modify.init(item) : mobContentObj.detail.init(item);
			});
		},
		move: function(index) {
			var item = this.rows[index];
			if(item.pchReqStCd === PCH_REQ_ST_CD_TEMP_SAVE) {
				var pageParam = {};
				pageParam['prevId'] = 'MPOMNG02010';
				pageParam['prevHref'] = '/app/mpomng/MPOMNG02010.html';
				pageParam['data'] = item;
				pageParam['prevData'] = item;
				sessionStorage.setItem(CMD_PAGE_MOVE_PARAM, JSON.stringify(item));
				fn_make_slide_menu.loadPage('MPOMNG01010', MOBILE_CONTEXTPATH + '/app/mpomng/MPOMNG01010.html')
			} else {
				mobContentObj.detail.init(item);
			}
		}
	},
	detail: {
		rows: [],
		init: function(item) {
			mobPageObj.switchScreen(VIEW_MODE_DETAIL);
			this.search(item);
		},
		search: function(item) {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				_this.rows = result.pchReqDtlList;
				_this.view(result);
			};
			const param = {'brandId':fn_make_user_info.get('brandId'), 'pchReqUnqNo': item.pchReqUnqNo};
			fn_ajax_call(API_MOBILE_INFO, param, callbackFn, 'GET');
		},
		view: function(result) {
			var _this = this;
			var id = '#ITP_AJAX_MPOMNG02010_DETAIL_CONTAINER';
			$(id).find('.fnDlvReqDt').text(result.dlvReqDt);
			$(id).find('.fnPchReqTotalAmt').text(CommonObj.currency.add(result.pchReqTotalAmt));
			$(id).find('.fnLocationNm').text(result.locationNm);
			$(id).find('.fnPchApprNm').text('(' + result.pchApprNm + ')' + CommonObj.currency.add(result.pchApprAmt));
			$.each(result.pchReqDtlList, function (i, item) {
				$('#ITP_LIST_MPOMNG02010_DETAIL_AREA .panel-group').append($('#ITP_LIST_MPOMNG02010_DETAIL_ROWCOPY').html());
				var $li = $('#ITP_LIST_MPOMNG02010_DETAIL_AREA .panel-group > .list-row:last');
				$li.find('.fnItemNm').text(item.itemNm);
				$li.find('.fnUnit').text(item.pchReqQty + item.unit);
				$li.find('.fnPchReqAmt').text(CommonObj.comma.set(item.pchReqAmt));
				$li.find('.fnPchReqQty').text(CommonObj.currency.add(item.pchReqQty, ''));
				_this.rows.push(item);
			});
		},
		cancel: function () {
			this.rows.length = 0;
			var id = '#ITP_AJAX_MPOMNG02010_DETAIL_CONTAINER';
			$(id).find('.fnDlvReqDt').text('');
			$(id).find('.fnPchReqTotalAmt').text('');
			$(id).find('.fnLocationNm').text('');
			$(id).find('.fnPchApprNm').text('');
			$('#ITP_LIST_MPOMNG02010_DETAIL_AREA .panel-group').empty();
			mobPageObj.switchScreen(VIEW_MODE_LIST);
		}
	},
	modify: {
		rows: [],
		init: function(item) {
			mobPageObj.switchScreen(VIEW_MODE_MODIFY);
			this.clear();
			this.event();
			this.search(item);
		},
		event: function() {
			var _this = this;
			$('button[id^="ITP_BTN_MPOMNG02010_MODIFY"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MPOMNG02010_MODIFY_SEARCH_WHS_NM'		: mobPopObj.popWhsNm.init(VIEW_MODE_MODIFY); 	break;
					case 'ITP_BTN_MPOMNG02010_MODIFY_DELETE_WHS_NM'		: mobPopObj.popWhsNm.delete(VIEW_MODE_MODIFY); 	break;
					case 'ITP_BTN_MPOMNG02010_MODIFY_ADD_ROW'			: mobContObj.cancel();				break;
					case 'ITP_BTN_MPOMNG02010_MODIFY_DEL_ROW'			: mobPopObj.popWhsNm.delete();		break;
					case 'ITP_BTN_MPOMNG02010_MODIFY_REQ_ORDER'			: mobContObj.cancel();				break;
					case 'ITP_BTN_MPOMNG02010_MODIFY_TEMP_SAVE'			: mobContObj.cancel();				break;
					case 'ITP_BTN_MPOMNG02010_MODIFY_CANCEL'			: _this.cancel();					break;
				}
				return false;
			});
		},
		search: function(item) {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result);
			};
			const param = {'brandId':fn_make_user_info.get('brandId'), 'pchReqUnqNo': item.pchReqUnqNo};
			fn_ajax_call(API_MOBILE_INFO, param, callbackFn, 'GET');
		},
		view: function(result) {
			var _this = this;
			var id = '#ITP_AJAX_MPOMNG02010_MODIFY_CONTAINER';
			$(id).find('.fnDlvReqDt').text(result.dlvReqDt.replace(/./g, "-"));
			$(id).find('.fnPchReqTotalAmt').text(CommonObj.currency.add(result.pchReqTotalAmt));
			$(id).find('.fnOrdUseAmt').text(CommonObj.currency.add(result.ordUseAmt));
			$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_NM').val(result.whsNm);
			$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_ID').val(result.whsId);
			$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_LOCATION').val(result.location);
			$.each(result.pchReqDtlList, function (i, item) {
				_this.list.attachRow(item);
			});
		},
		list: {
			rows: [],
			attachRow: function (item) {
				var fnIsExist = function(rows) {
					var isExist = false;
					$.each(rows, function(i, row) {
						if(row.brandUnitUnqNo === item.brandUnitUnqNo) {
							isExist = true;
							return false;
						}
					});
					return isExist;
				};
				if(!fnIsExist(this.rows)) {
					this.rows.push(item);
					$('#ITP_LIST_MPOMNG02010_MODIFY_AREA .panel-group').append($('#ITP_LIST_MPOMNG02010_MODIFY_ROWCOPY').html());
					var $li = $('#ITP_LIST_MPOMNG02010_MODIFY_AREA .panel-group > .list-row:last');
					$li.find('.fnBrandUnitUnqNo').val(item.brandUnitUnqNo);
					$li.find('.fnItemNm').text(item.itemNm);
					$li.find('.fnPchReqQty').text(item.pchReqQty);
					$li.find('.fnUnitAmt').text(CommonObj.currency.add(item.unitAmt));
					this.pchReqAmtTot();
				}
			},
			detachRow: function () {
				if($('#ITP_LIST_MPOMNG01010_ITEM_AREA input:checkbox[name=brandUnitUnqNo]:checked').length > 0) {
					var _this = this;
					$('#ITP_LIST_MPOMNG01010_DETAIL_ROWS li').each(function(index, elem) {
						var isChecked = $(this).find('input[type="checkbox"]').is(':checked');
						if(isChecked) {
							$(this).remove();_this.rows.splice(index, 1);
						}
					});
					this.pchReqAmtTot();
				}
			},
			actPlus: function(elem) {
				var $div = $(elem).siblings('div');
				var num = Number($div.text());
				$($div).text((num + 1).toString());
				this.rows[$div.parents('li').index()]['pchReqQty'] = $($div).text();
				this.pchReqAmtTot();
			},
			actMinus: function(elem) {
				var $div = $(elem).siblings('div');
				var num = Number($div.text());
				if(num <= 1) {
					alert('주문수량을 확인하세요.');
				} else {
					$($div).text((num - 1).toString());
					this.rows[$div.parents('li').index()]['pchReqQty'] = $($div).text();
					this.pchReqAmtTot();
				}
			},
			pchReqAmtTot: function() {
				var reqAmt = 0;
				$.each(this.rows, function(index, item) {
					var qty = item.pchReqQty;
					var amt = item.unitAmt;
					reqAmt += Number(qty) * amt;
				});
				$('#ITP_AJAX_MPOMNG01010_VIEW_CONTAINER').find('.fnPchReqAmtTot').text(CommonObj.currency.add(reqAmt));
			}
		},
		cancel: function () {
			this.clear();
			mobPageObj.switchScreen(VIEW_MODE_LIST);
		},
		clear: function() {
			this.rows.length = 0;
			var id = '#ITP_AJAX_MPOMNG02010_MODIFY_CONTAINER';
			$(id).find('.fnDlvReqDt').val('');
			$(id).find('.fnPchReqTotalAmt').text('');
			$(id).find('.fnOrdUseAmt').text('');
			$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_NM').val('');
			$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_ID').val('');
			$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_LOCATION').val('');
			$('#ITP_LIST_MPOMNG02010_MODIFY_AREA .panel-group').empty();
		}
	}
};

let mobPopObj = {
	popWhsNm: {
		mode: '',
		init: function (mode) {
			this.mode = mode;
			this.rows.length = 0;
			mobPopObj.show(this.popId);
			this.search();
			this.action();
		},
		popId: 'ITP_POP_MPOMNG02010_WHS_AREA',
		rows: [],
		search: function () {
			var _this = this;
			$('#ITP_LIST_MPOMNG02010_POP_WHS_AREA .panel-group').empty();
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result.gridRows);
			};
			const param = $('#ITP_FORM_MPOMNG02010_POP_WHS').serializeObject();
			fn_ajax_call(API_POP_SEARCH_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		view: function(gridRows) {
			this.rows = gridRows;
			$.each(gridRows, function (i, item) {
				$('#ITP_LIST_MPOMNG02010_POP_WHS_AREA .panel-group').append($('#ITP_LIST_MPOMNG02010_POP_WHS_ROWCOPY').html());
				var $li = $('#ITP_LIST_MPOMNG02010_POP_WHS_AREA .panel-group > .row_2:last');
				$li.find('.fnWhsNm').text(item.whsNm);
				$li.find('.fnLocationNm').text(item.locationNm);
				$li.find('.fnWhsId').data('whs-id', item.whsId);
			});
		},
		choice: function(elem) {
			var _this = this;
			var whsId = $(elem).data('whs-id');
			$.each(this.rows, function (i, item) {
				if(whsId === item.whsId) {
					if(_this.mode === VIEW_MODE_LIST) {
						$('#ITP_FORM_MPOMNG02010_SEARCH #ITP_FORM_MPOMNG02010_SEARCH_WHS_ID').val(item.whsId);
						$('#ITP_FORM_MPOMNG02010_SEARCH #ITP_FORM_MPOMNG02010_SEARCH_WHS_NM').val(item.whsNm);
					} else if(_this.mode === VIEW_MODE_MODIFY) {
						$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_ID').val(item.whsId);
						$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_NM').val(item.whsNm);
						$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_LOCATION').val(item.location);
					}
					mobPopObj.hide(_this.popId);
					return false;
				}
			});
		},
		action: function() {
			var _this = this;
			$('button[id^="ITP_BTN_MPOMNG02010_POP"]').off('click').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MPOMNG02010_POP_WHS_SEARCH'	: _this.search();				break;
					case 'ITP_BTN_MPOMNG02010_POP_WHS_CHOICE'	: _this.choice($(this)); 		break;
					case 'ITP_BTN_MPOMNG02010_POP_WHS_CLOSE'	: mobPopObj.hide(_this.popId);	break;
				}
				return false;
			});
		},
		delete: function(mode) {
			if(mode === VIEW_MODE_LIST) {
				$('#ITP_FORM_MPOMNG02010_SEARCH #ITP_FORM_MPOMNG02010_SEARCH_WHS_ID').val('');
				$('#ITP_FORM_MPOMNG02010_SEARCH #ITP_FORM_MPOMNG02010_SEARCH_WHS_NM').val('');
			} else if(mode === VIEW_MODE_MODIFY) {
				$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_ID').val('');
				$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_WHS_NM').val('');
				$('#ITP_FORM_MPOMNG02010_MODIFY #ITP_FORM_MPOMNG02010_MODIFY_LOCATION').val('');
				mobPopObj.hide(ID_ITP_POP_MPOMNG01010_WHS_AREA);
			}
		}
	},
	show: function(popId) {
		$('#' + popId).show();
	},
	hide: function(popId) {
		$('#' + popId).closest('.mobile-pop-close').hide();
	}
};
